package juniq;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import java.util.concurrent.*;
import java.security.*;
import javax.swing.table.*;

public class EmptyFoldersGenerate extends JFrame
{
    JTextArea scriptname = new JTextArea("/tmp/emptyfolders-script.sh");
    JButton genbutton = new JButton("Generate Script");
    JTextArea action = new JTextArea("rm -r $'$1'");
    JCheckBox showprogress = new JCheckBox("", true);

    public static final long serialVersionUID = 1001;

    EmptyFolders ef;

    public EmptyFoldersGenerate(EmptyFolders ef)
    {
	super("Script Generator");

	this.ef=ef;

	Container me = getContentPane();

	me.setLayout(new GridLayout(3,2));

	me.add(new JLabel("Output script name"));
	me.add(scriptname);

	me.add(new JLabel("Show progress: "));
	me.add(showprogress);

	me.add(new JLabel(" "));
	me.add(genbutton);

	genbutton.addActionListener(new ActionListener() 
	    { public void actionPerformed(ActionEvent e) { generate(); }});

	setSize(400,250);
	setVisible(false);
    }

    public void generate()
    {
	try {
	    generateReal();
	    setVisible(false);
	} catch (IOException ex) {
	    System.out.println("unexpected exception: "+ex);
	}
    }

    public void generateReal() throws IOException
    {
	FileWriter outs = new FileWriter(scriptname.getText());
	Progress p;
	int pos;

	outs.write("# EmptyFolders-generated removal script\n");
	outs.write("# \n");
	outs.write("# symlinks\n");

	p = new Progress("Empty Directories  ", outs, ef.emptyDirs.size());
	pos=0;
	p.start();
	for (File f: ef.emptyDirs)
	    {
		removefile(outs, f);
		p.progress(pos++);
	    }

	p.end();

	outs.write("# End of file\n");
	outs.flush();
	outs.close();
    }

    public void removefile(FileWriter outs, File f) throws IOException
    {
	String n = action.getText();
	n = n.replace("$0",f.getAbsolutePath());
	n = n.replace("$1",escape(f.getAbsolutePath()));
	outs.write(n+"\n");
    }

    public String escape(String s)
    {
	StringBuffer sb = new StringBuffer();

	for (int i=0;i<s.length();i++)
	    {
		char c = s.charAt(i);
		if (c==' ' || c=='.' || c=='/' || Character.isLetterOrDigit(c))
		    sb.append(c);
		else
		    sb.append(String.format("\\x%2x", c&0xff));
	    }
	return sb.toString();
    }

    class Progress
    {
	int lastpercent;
	String s;
	FileWriter outs;
	int max;

	public Progress(String s, FileWriter outs, int max)
	{
	    this.s=s;
	    this.outs=outs;
	    this.max=max;
	}

	public void progress(int value) throws IOException
	{
	    int percent = value*100/max;

	    if (percent>lastpercent)
		{
		    percent(percent);
		    lastpercent=percent;
		}
	}

	public void start() throws IOException
	{
	    percent(0);
	}

	public void end() throws IOException
	{
	    percent(100);
	    outs.write("echo\n");
	}

	void percent(int p) throws IOException
	{
	    if (!showprogress.isSelected())
		return;

	    outs.write(String.format("echo -en \"\\r%s [%3d%%]\"\n", s, p));
	}
    }
}
